;Input:		Var(HL),C
;Output:	Var(HL) = int Var(HL)/C
;			A = remainder
;			CF = C if C = 0, else CF = NC
;			B,DE destroyed
;			C,HL preserved

DivideVar8:
 ld (SaveHL),hl
 ld a,c
 or a
 scf
 ret z			;return with CF = C if C = 0 (division by 0)
 call LengthVar	;E = length of var(HL)
 ret z			;return if 0 length
 ld a,e
 add a,a
 add a,a
 add a,a		;length * 8
 ld b,a			;how many bits to shift out
 ld a,8
 sub e			;A = how many loops to skip in rotating function
 ld e,a
 add a,a
 add a,e		;3 bytes per rotating loop
 ld e,a
 ld hl,RLVar	;HL -> rotating function
 add hl,de		;add number of bytes to skip + address
 ld (&DV8_RLVar+1),hl	;save into routine below
 ld hl,(SaveHL)	;HL -> dividend

 xor a			;A = 0 = remainder
DV8_Loop:
 or a
DV8_RLVar:
 call RLVar+0	;rotate left bit out of dividend
 ld hl,(SaveHL)
 rla			;rotate bit into remainder
 cp c			;compare to divisor
 jr c,DV8_NextBit	;if divisor > remainder, jump
 sub c			;else, subtract to update remainder
 inc (hl)		;set bit 0 of dividend (later to be quotient)
DV8_NextBit:
 djnz DV8_Loop
 or a
 ret
